$ontext


   Cutting Stock Example

   Erwin Kalvelagen, december 2002

   Data from Chvatal, Linear Programming, 1983.

$offtext


set
  i 'widths' /width1*width4/
  j 'patterns' /pattern1*pattern37/
;


*-----------------------------------------------------
* Data
*-----------------------------------------------------

scalar r 'raw width' /100/;

table demanddata(i,*)
           width  demand
  width1    45      97
  width2    36     610
  width3    31     395
  width4    14     211
;

table patterndata(j,i)
           width1  width2  width3  width4

pattern1     2
pattern2     1       1               1
pattern3     1       1
pattern4     1               1       1
pattern5     1               1
pattern6     1                       3
pattern7     1                       2
pattern8     1                       1
pattern9     1
pattern10            2               2
pattern11            2               1
pattern12            2
pattern13            1       2
pattern14            1       1       2
pattern15            1       1       1
pattern16            1       1
pattern17            1               4
pattern18            1               3
pattern19            1               4
pattern20            1               1
pattern21            1
pattern22                    3
pattern23                    2       2
pattern24                    2       1
pattern25                    2
pattern26                    1       4
pattern27                    1       3
pattern28                    1       2
pattern29                    1       1
pattern30                    1
pattern31                            7
pattern32                            6
pattern33                            5
pattern34                            4
pattern35                            3
pattern36                            2
pattern37                            1
;


parameter w(i);
w(i) = demanddata(i,'width');

parameter d(i);
d(i) = demanddata(i,'demand');

parameter a(i,j);
a(i,j) = patterndata(j,i);

abort$(sum(j$(sum(i, a(i,j)*w(i)) > r+0.0001), 1)) "Pattern exceeds raw width";

*-----------------------------------------------------
* MIP formulation
*-----------------------------------------------------

integer variable x(j) 'patterns used';
variable z 'objective';

*
* default integer upperbound of 100 is too tight
*
x.up(j) = sum(i, d(i));

equations
    numpat    'number of patters used (objective)'
    demand(i) 'meet demand'
;

numpat..     z =e= sum(j, x(j));
demand(i)..  sum(j, a(i,j)*x(j)) =g= d(i);

model cut1 /numpat,demand/;
option optcr = 0.0;
solve cut1 using MIP minimizing z;

display x.l;

